Subject: Re: [Roll] I-D Action: draft-ietf-roll-nsa-extension-02.txt

From: <[email-masked]>
Date: Mon, 1 Jul 2019 15:26:23 +0000

Hello Aris, Georgios and all,

[removing [email-masked]<mailto:[email-masked]> from the CC list]
Thanks for your the new draft revision and for your responses itemised below.
See my comments inline.
In short, 2 points out of 3 are "clear to go" from my side, and the third one is "ask Pascal, I leave him the final word".
Best regards,

Dominique

De : Roll <[email-masked]<mailto:[email-masked]>> on behalf of Remous-Aris Koutsiamanis <[email-masked]<mailto:[email-masked]>>
Répondre à : "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Date : Tuesday 25 June 2019 11:04
À : "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Cc : "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Objet : Re: [Roll] I-D Action: draft-ietf-roll-nsa-extension-02.txt

Hello,

we have updated the draft-ietf-roll-nsa-extension draft to address most of the comments from Dominique.
The remaining comments that we are awaiting an answer to follow below to make it easy to focus on the remaining issues.

Best,
Aris

On Mon, Jun 24, 2019 at 7:00 PM <[email-masked]<mailto:[email-masked]>> wrote:

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the Routing Over Low power and Lossy networks WG of the IETF.

        Title           : RPL DAG Metric Container Node State and Attribute object type extension
        Authors         : Remous-Aris Koutsiamanis
                          Georgios Papadopoulos
                          Nicolas Montavont
                          Pascal Thubert
        Filename        : draft-ietf-roll-nsa-extension-02.txt
        Pages           : 14
        Date            : 2019-06-24

Abstract:
   Implementing Packet Replication and Elimination from / to the RPL
   root requires the ability to forward copies of packets over different
   paths via different RPL parents.  Selecting the appropriate parents
   to achieve ultra-low latency and jitter requires information about a
   node's parents.  This document details what information needs to be
   transmitted and how it is encoded within a packet to enable this
   functionality.

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-ietf-roll-nsa-extension/

There are also htmlized versions available at:
https://tools.ietf.org/html/draft-ietf-roll-nsa-extension-02
https://datatracker.ietf.org/doc/html/draft-ietf-roll-nsa-extension-02

A diff from the previous version is available at:
https://www.ietf.org/rfcdiff?url2=draft-ietf-roll-nsa-extension-02

Please note that it may take a couple of minutes from the time of submission
until the htmlized version and diff are available at tools.ietf.org<http://tools.ietf.org>.

Internet-Drafts are also available by anonymous FTP at:
ftp://ftp.ietf.org/internet-drafts/

_______________________________________________
Roll mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/roll

Comments from Dominique:
On Wed, Jun 19, 2019 at 5:11 PM <[email-masked]<mailto:[email-masked]>> wrote:

  *   section 4.1.1: in RFC6551, the Prec field is meant to be used for metrics, not for constraints. Therefore, it is unused for this NSA extension, which is a constraint. Unfortunately, RFC6551 forgot to specify a default value. Is this the reason why you say “used according to RFC…”? I suggest you use the same text for the Prec and A fields. It could be quoting the text from RFC6551, of referring the reader to it, or say nothing.
  *   section 4.1.2: “For clarity reasons, the usage of the PS places no additional restrictions on the NSA flags (’A’ and ’O’), which can be used as normally defined in [RFC6550]”. The clarity reasons escaped me, as well as the additional restrictions that could have been placed but which have not! Anyway, RFC6551 states that the A Field is not used with constraints. Overall, I think this whole subsection could go away since it specifies nothing, says that it does not specify anything but does not say why it says it. ;-)

We replaced 4.1.1 and 4.1.2 with just "The PS is used only within NSA objects configured as constraints and is used as per [RFC6551<https://datatracker.ietf.org/doc/html/rfc6551>]." in Section 4.1
[DB] sounds good.

  *   Section 4.2: "Therefore, the PS IPv6 address(es) field SHOULD be compressed using the compression method for Source Routing Header 6LoRH (SRH-6LoRH)". I understand that a similar compression mechanism could be used. However, this requires defining a protocol element that does not exist today, unless I missed something. Therefore, the normative SHOULD is irrelevant. I guess this section is merely suggesting future work.

We do have this almost fully implemented (almost: only works in single root RPL instances).
Would it make sense to spell out the exact specification of the compression even if it is largely a copy of the SRH-6LoRH compression method?
I can lowercase the SHOULD, but using this kind of compression really makes big difference in practice.
[DB] talk to Pascal about this, he looks pretty knowledgeable in SHOULDs. Anyway, if you capitalise SHOULD, then you have to explain the consequences of not following the recommendation. Whereas if you lowercase it, it's only free advice. You can stil explain why you think it is a good idea. My worry is that a capitalised SHOULD here will stop the draft later in the IESG processing because you are referring to a non-existent specification (formally speaking). Again, ask Pascal, I totally trust him on this question.

  *   Appendix A: does the experimental implementation do compression? If so, for information, what's the DIO size?

Yes, it does do compression.
The size depends on the other DIO options present.
We have tested using Contiki with 802.15.4-TSCH, so the max packet size is 127 bytes without fragmentation.
Without compression we can fit max 2 parents in the PS and we have to remove the Prefix Information Option (if i remember correctly).
I can look up the actual byte count if that's helpful.
[DB] fine, I was just curious. Good to hear that this compression is actually implemented, even at preliminary stage.

Comments from Abdussalam:
On Mon, Jun 17, 2019 at 1:10 AM Abdussalam Baryun <[email-masked]<mailto:[email-masked]>> wrote:
Hi Ines and Peter,

IMHO the draft is not clear in its use-case, I think it must include rfc8578 to clarify its usecase, and using references of architectures does not help us understand but makes it more difficult.

Thank you very much for reading this draft and providing us with your comments. It is very much appreciated.

I would like to ask some clarifying questions if you don't mind.
"the draft is not clear in its use-case, I think it must include rfc8578 to clarify its usecase"
We are aware of the DetNet usecases and following your comment we will point to the rfc8578 and specifically Section 5. Wireless for Industrial Applications, which is what we are aiming at with this draft.
We have attempted to strike a balance between the introductory material present in the draft (to help it stand alone) and referencing other sources to avoid reiterating things.
If you think that just referencing rfc8578 Section 5. Wireless for Industrial Applications is insufficient, maybe you could provide a bit more detail on what should and should not be present in the draft.

"using references of architectures does not help us understand but makes it more difficult"
Could you please be more explicit?
We reference two architectures in this draft.
In Section 1 Introduction, we refer to the 6TiSCH architecture, as the base upon which this draft builds.
In Section 1 Introduction  we reference the DetNet architecture as context for aim of maximizing packet delivery rate and minimizing latency and jitter.
In Section 5 Controlling PRE we reference the DetNet architecture specifically as an example to allow the fine-grained control of PRE usage via flow labels.

Which of these or other references to architectures did you have in mind?

[https://ssl.gstatic.com/ui/v1/icons/mail/images/cleardot.gif]

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc
pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler
a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,
Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;
they should not be distributed, used or copied without authorisation.
If you have received this email in error, please notify the sender and delete this message and its attachments.
As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.
Thank you.

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 1 Jul 2019 15:44:34 +0000

Happy to contribute : )

Can someone summarize the discussion?

All the best,

Pascal

From: [email-masked] <[email-masked]>
Sent: lundi 1 juillet 2019 17:26
To: Routing Over Low power and Lossy networks <[email-masked]>; [email-masked]; Pascal Thubert (pthubert) <[email-masked]>; Georgios Z. Papadopoulos <[email-masked]>
Subject: Re: [Roll] I-D Action: draft-ietf-roll-nsa-extension-02.txt

Dominique

Hello,

Best,
Aris

Abstract:

Comments from Dominique:

Thank you.

---

From: "Georgios Z. Papadopoulos" <[email-masked]>
Date: Mon, 1 Jul 2019 17:51:40 +0200

Hello Pascal,

Below is the summarized discussion.

Basically, is it good idea to use capitalized "SHOULD”" or lower case “should” when talking about compressing the parent address list.
In the draft we suggest using a implementation similar to SRH-6LoRH for the IPv6 address (which we have implemented in Contiki btw).
However, its similar but not identical to the one in SRH-6LoRH.
Dominique says, if we use capitalized “SHOULD” then it might create problems in the WGLC, if we do not have have an explicit spec.
Thus, in the -3 version we have used lower case "should”.

What do you think?
Georgios and Aris

— — — 

Happy to contribute : )

All the best,
 
Pascal

> On Jul 1, 2019, at 17:44, Pascal Thubert (pthubert) <[email-masked]> wrote:
> 
> Section 4.2: "Therefore, the PS IPv6 address(es) field SHOULD be compressed using the compression method for Source Routing Header 6LoRH (SRH-6LoRH)". I understand that a similar compression mechanism could be used. However, this requires defining a protocol element that does not exist today, unless I missed something. Therefore, the normative SHOULD is irrelevant. I guess this section is merely suggesting future work.

---

From: <[email-masked]>
Date: Mon, 1 Jul 2019 15:52:46 +0000

Hello Pascal,

Here is the point being discussed. (see the surrounding text at https://tools.ietf.org/html/draft-ietf-roll-nsa-extension-03#section-4.2)

Best regards
Dominique

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 1 Jul 2019 17:52:40 +0000

I agree 100% with Dominique.

I d remove the text altogether since there is no compression RFC and that would block this draft.

And... Let’s start the PL control plane compression draft!

Regards,

Pascal

Le 1 juil. 2019 à 17:52, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>> a écrit :

Hello Pascal,

Best regards
Dominique

---

From: Remous-Aris Koutsiamanis <[email-masked]>
Date: Tue, 2 Jul 2019 17:39:55 +0200 (CEST)

Hello again,

just two really quick clarifications...

> I d remove the text altogether since there is no compression RFC and that

You propose to remove the whole section regarding the compression?
(https://tools.ietf.org/html/draft-ietf-roll-nsa-extension-03#section-4.2
<https://tools.ietf.org/html/draft-ietf-roll-nsa-extension-03#section-4.2>)

> And... Let’s start the PL control plane compression draft!

What does PL stand for here? You maybe mistyped RPL?
And if yes, this would a wider effort, right?

Best,
Aris